| package |
package := Package name: 'AIDAWeb'.
package paxVersion: 1;
	basicComment: 'AIDA/Web, Smalltalk Web Application server

Web server and framework for complex web applications with integrated Ajax support, rich collection of web components to build web pages programatically, MVC-like separation of presentation from domain, nice looking and bookmarkable url links, with integrated session and security management and many more.

Installation:
- install package Swazoo.pac from directory Swazoo
- install package AIDAWeb.pac from directory AIDAWeb
- evaluate SwazooServer demoStart
- in web browser open http://localhost:8888
- login with username: admin, password: password

More on:
- http://www.eranova.si/aida
- on-line demo and discussion on http://aida.eranova.si
- tutorial on http://www.swazoo.org/aida-tutorial.html

(c) Janko Mivsek, Eranova d.o.o. Slovenia, janko.mivsek@eranova.si'.


package methodNames
	add: #AIDAInstallSwazooAIDA -> #justToForceInstallation;
	add: #AIDAInstallSysChanges -> #justToForceInstallation;
	add: 'AIDASite class' -> #justToForceInstallation;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: 'AIDA core';
	add: 'AIDA System Changes';
	add: 'Swazoo-AIDA';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!AIDAInstallSwazooAIDA methodsFor!

justToForceInstallation! !
!AIDAInstallSwazooAIDA categoriesFor: #justToForceInstallation!private! !

!AIDAInstallSysChanges methodsFor!

justToForceInstallation! !
!AIDAInstallSysChanges categoriesFor: #justToForceInstallation!private! !

!AIDASite class methodsFor!

justToForceInstallation! !
!AIDASite class categoriesFor: #justToForceInstallation!private! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

